//****************************************************************************
// @Module        Project Settings
// @Filename      MAIN.C
// @Project       timer.dav
//----------------------------------------------------------------------------
// @Controller    Infineon C167CS-L
//
// @Compiler      Tasking
//
// @Codegenerator 2.3
//
// @Description   This file contains the project initialization function.
//
//----------------------------------------------------------------------------
// @Date          4/28/2010 1:03:43 AM
//
//****************************************************************************

// USER CODE BEGIN (MAIN_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (MAIN_General,2)

#include <stdlib.h>

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (MAIN_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (MAIN_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (MAIN_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (MAIN_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (MAIN_General,9)

// USER CODE END


//****************************************************************************
// @Function      void MAIN_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          4/28/2010
//
//****************************************************************************

// USER CODE BEGIN (Init,1)

// USER CODE END

void MAIN_vInit(void)
{
  // USER CODE BEGIN (Init,2)

  // USER CODE END

  //// -----------------------------------------------------------------------
  //// Begin of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------
  ///  All following settings must be set in the start-up file. You can use 
  ///  DAvE's project file (*.dpt) to include this register values into your 
  ///  compiler EDE.

    ///  ---------------------------------------------------------------------
    ///  Initialization of the XPERCON Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// XPERCON  =  0x0401

    ///  ---------------------------------------------------------------------
    ///  Initialization of the XADRS5 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// XADRS5  =  0x0080

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON Register:
    ///  ---------------------------------------------------------------------
    ///  - 256 words system stack
    ///  - Internal ROM area mapped to segment 1
    ///  - the segmentation is enabled (CSP is saved/restored during 
    ///  interrupt entry/exit)
    ///  - Internal ROM disabled
    ///  - the pin #BHE is disabled
    ///  - system clock output CLKOUT is disabled
    ///  - latched #CS mode
    ///  - pin #RSTIN is an input only
    ///  - the on-chip X-Peripherals are enabled and can be accessed
    ///  - accesses to the XBUS peripherals are done internally
    ///  - external accesses to XBUS peripherals are disabled

    //// this register must be set in the start-up file
    //// SYSCON  =  0x1214

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON1 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON1  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON2 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON2  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON3 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON3  =  0x4000

    ///  ---------------------------------------------------------------------
    ///  --- initialization of the BUSCON 0-4 and ADRRSEL Registers 1-4 ---
    ///  ---------------------------------------------------------------------


    ///  ---------------------------------------------------------------------
    ///  ---------- external bus 0 is enabled ----------
    ///  ---------------------------------------------------------------------
    ///  - 16-bit Multiplexed Bus
    ///  - signal configuration: disable READY signal
    ///  - memory cycle time control: 15 waitstates
    ///  - With read/write delay: activate command 1 TCL after falling edge 
    ///  of ALE
    ///  - chip select mode: address chip select
    ///  - memory tristate control: 1 waitstate
    ///  - ALE lengthening control: lengthened ALE signal
    ///  - Address windows are switched immediately
    ///  - Normal #WR signal

    //// this register must be set in the start-up file
    //// BUSCON0  =  0x06C0




  //// -----------------------------------------------------------------------
  //// End of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------


  ///  external bus arbitration is disabled, P6.7...P6.5 may be used for 
  ///  general purpose I/O


  //   -----------------------------------------------------------------------
  //   Initialization of the Peripherals:
  //   -----------------------------------------------------------------------

  //   initializes the Parallel Ports
  IO_vInit();

  //   initializes the Watchdog Timer (WDT)
  WDT_vInit();

  // USER CODE BEGIN (Init,3)

  // USER CODE END

  //   globally enable interrupts
  PSW_IEN        =  1;          

} //  End of function MAIN_vInit


//****************************************************************************
// @Function      void main(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          4/28/2010
//
//****************************************************************************

// USER CODE BEGIN (Main,1)

// USER CODE END

void main(void)
{
  // USER CODE BEGIN (Main,2)
  unsigned int success_counter = 0;

  // USER CODE END

  MAIN_vInit();

  // USER CODE BEGIN (Main,4)

  // start sequence
  turn_all_leds_slowly_on();
  turn_all_leds_slowly_off();
  turn_all_leds_slowly_on();

  // wait for start signal
  wait_for_button_on_off(0);

  turn_all_leds_slowly_off();

  while(1) {
    while(!IO_ubReadPin(IO_P3_0)); // wait if button is still on
    wait((rand() % 50)+5); // wait between 0 and 19
    turn_leds_0to7_on();
    wait_for_button_on_off(1);
    turn_leds_0to7_off();
    // we are still here? => super, fast enough!
    count_leds_8to15_up(success_counter);
	if(++success_counter==8) success_counter=0;
	// reduce watchdog time
	WDTCON += 0x1E00;
  }
   
  // USER CODE END

} //  End of function main



// USER CODE BEGIN (MAIN_General,10)


/*
 * wait for button on/off
 * if no button-off signal comes within WDT-time => reset
 */
void wait_for_button_on_off(char fast) {
  while(1) {
    if(!fast) WDT_vTriggerWDT();
    if(!IO_ubReadPin(IO_P3_0)) { //IO_ubReadPin has inverted logic!
      while(1) {
        if(IO_ubReadPin(IO_P3_0)) {
          WDT_vTriggerWDT();
          return;
		}
	  }
    }
  }
}

/*
 * show counter using leds 8 to 15
 */
void count_leds_8to15_up(unsigned int x) {
  switch(x) {
  case 0:
    turn_leds_8to15_off();
    IO_vResetPin(IO_P2_8);
    break; 
  case 1:
    IO_vResetPin(IO_P2_9);
    break;
  case 2:
    IO_vResetPin(IO_P2_10);
    break;
  case 3:
    IO_vResetPin(IO_P2_11);
    break;
  case 4:
    IO_vResetPin(IO_P2_12);
    break;
  case 5:
    IO_vResetPin(IO_P2_13);
    break;
  case 6:
    IO_vResetPin(IO_P2_14);
    break;
  case 7:
    IO_vResetPin(IO_P2_15);
    break;
  }
}

void turn_all_leds_slowly_on(void) {  
  IO_vResetPin(IO_P2_0); IO_vResetPin(IO_P2_8);
  wait(1);

  IO_vResetPin(IO_P2_1); IO_vResetPin(IO_P2_9);
  wait(1);

  IO_vResetPin(IO_P2_2); IO_vResetPin(IO_P2_10);
  wait(1);

  IO_vResetPin(IO_P2_3); IO_vResetPin(IO_P2_11);
  wait(1);

  IO_vResetPin(IO_P2_4); IO_vResetPin(IO_P2_12);
  wait(1);

  IO_vResetPin(IO_P2_5); IO_vResetPin(IO_P2_13);
  wait(1);

  IO_vResetPin(IO_P2_6); IO_vResetPin(IO_P2_14);
  wait(1);

  IO_vResetPin(IO_P2_7); IO_vResetPin(IO_P2_15);
  wait(1);
}

void turn_all_leds_slowly_off(void) {  
  IO_vSetPin(IO_P2_7); IO_vSetPin(IO_P2_15);
  wait(1);

  IO_vSetPin(IO_P2_6); IO_vSetPin(IO_P2_14);
  wait(1);

  IO_vSetPin(IO_P2_5); IO_vSetPin(IO_P2_13);
  wait(1);

  IO_vSetPin(IO_P2_4); IO_vSetPin(IO_P2_12);
  wait(1);

  IO_vSetPin(IO_P2_3); IO_vSetPin(IO_P2_11);
  wait(1);
  
  IO_vSetPin(IO_P2_2); IO_vSetPin(IO_P2_10);
  wait(1);

  IO_vSetPin(IO_P2_1); IO_vSetPin(IO_P2_9);
  wait(1);

  IO_vSetPin(IO_P2_0); IO_vSetPin(IO_P2_8);
  wait(1);
}

void turn_leds_0to7_on(void) {
  IO_vResetPin(IO_P2_0);
  IO_vResetPin(IO_P2_1);
  IO_vResetPin(IO_P2_2);
  IO_vResetPin(IO_P2_3);
  IO_vResetPin(IO_P2_4);
  IO_vResetPin(IO_P2_5);
  IO_vResetPin(IO_P2_6);
  IO_vResetPin(IO_P2_7);
}

void turn_leds_0to7_off(void) {
  IO_vSetPin(IO_P2_0);
  IO_vSetPin(IO_P2_1);
  IO_vSetPin(IO_P2_2);
  IO_vSetPin(IO_P2_3);
  IO_vSetPin(IO_P2_4);
  IO_vSetPin(IO_P2_5);
  IO_vSetPin(IO_P2_6);
  IO_vSetPin(IO_P2_7);
}

void turn_leds_8to15_off(void) {
  IO_vSetPin(IO_P2_8);
  IO_vSetPin(IO_P2_9);
  IO_vSetPin(IO_P2_10);
  IO_vSetPin(IO_P2_11);
  IO_vSetPin(IO_P2_12);
  IO_vSetPin(IO_P2_13);
  IO_vSetPin(IO_P2_14);
  IO_vSetPin(IO_P2_15);
}

// wait for an unspecified timeframe...
void wait(unsigned int x) {
  unsigned int i, j;
  for(i=0; i<x; i++) {
    WDT_vTriggerWDT();
    for(j=0; j<30000; j++);
  }
}

// USER CODE END

